Bug 446138

Summary: Xenner leaks TAP device upon failure
Product: [Fedora] Fedora Reporter: Daniel Berrange <berrange>
Component: xennerAssignee: Gerd Hoffmann <kraxel>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: low Docs Contact:
Priority: low    
Version: 9CC: berrange
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2008-05-19 06:39:26 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 435059    

Description Daniel Berrange 2008-05-12 19:08:40 EDT
bDescription of problem:
During startup of a VM, Xenner enables the TUNSETPERSIST flag for the TAP device
it is passed. The network device details are not written into Xenstore for
netbackd until later during Xenner startup, and netbackd then makes it non
persistent. If Xenner fails during this window for any reason, you are left with
a TAP device that will never go away.

Version-Release number of selected component (if applicable):
xenner-0.33

How reproducible:
Always

Steps to Reproduce:
1. Invoke xenner passing a pre-allocated TAP filedescriptor in the -net command
line arg, along with another arg that will cause it to fail to boot - eg point
it to a disk image which doesn't have any OS installed, so pygrub fails, or
don't start the 'xenner' initscript.
2. ifconfig -a
3.
  
Actual results:
xenner quits, but tap device still exists

Expected results:
xenner quits and device goes away

Additional info:
It appears the only reason Xenner makes the TAP device persistent is so that
netbackd can then open the interface. Might it be possible to avoid this
approach by having Xenner pass the FD directly to netbackd over a UNIX domain
socket using SCM_RIGHTS ?
Comment 1 Bug Zapper 2008-05-14 07:03:53 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Gerd Hoffmann 2008-05-19 06:39:26 EDT
Fixed in 0.35.